#!/usr/bin/perl -w
#
#    Copyright (c) 2003 Riad S. Wahby, <rsw@jfet.org>
#
#    This file is part of the Nixie-1 clock code.
#
#    The Nixie-1 clock code is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

while (<>)
{
    chomp;
    if (/\( (....), 0x(..) \)/)
    {
        $addr = $1;
        $data = $2;

        $addr = sprintf("%4.4x", 2*hex($addr) + hex("0x4200"));
        $data = $data . "00";
        $strn = "02" . $addr . "00" . $data;
        $tot = 0;
        @nums = (split(//,$strn));
        for ($i=0; $i<=$#nums; $i+=2)
        {
            $tot += hex($nums[$i] . $nums[$i+1]);
        }
        $cksm = sprintf("%2.2x", 256 - ($tot % 256));
        print ":" . $strn . $cksm, "\n";
    }
    else
    {
        die "Regexp didn't match\n";
    }
}
